unit WebModuleUnit1;

interface

uses
  System.SysUtils, System.Classes, Web.HTTPApp;

type
  TWebModule1 = class(TWebModule)
    procedure WebModule1DefaultHandlerAction(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  WebModuleClass: TComponentClass = TWebModule1;

implementation

uses
  Sparkle.WebBroker.Server,
  Sparkle.WebBroker.Adapter,
  XData.Server.Module, ConnectionModule, Aurelius.Engine.DatabaseManager;

{%CLASSGROUP 'System.Classes.TPersistent'}

{$R *.dfm}

var
  Server: TWebBrokerServer;


//-------------   Before ----------------
//procedure TWebModule1.WebModule1DefaultHandlerAction(Sender: TObject;
//  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
//var
//  Adapter: IWebBrokerAdapter;
//begin
//  Adapter := TWebBrokerAdapter.Create(Request, Response);
//  Server.DispatchRequest(Adapter);
//end;
//
//initialization
//  Server := TWebBrokerServer.Create;
//  FireDacPostgreSQLConnection := TFireDacPostgreSQLConnection.Create(nil);
//  TDatabaseManager.Update(TFireDacPostgreSQLConnection.CreateConnection);
//
//  Server.Dispatcher.AddModule(TXDataServerModule.Create(
//    'http://ubuntu/slimzulu', TFireDacPostgreSQLConnection.CreateConnection
//  ));
//finalization
//  Server.Free;
//  FireDacPostgreSQLConnection.Free;


//---------------------  After --------------------------
procedure TWebModule1.WebModule1DefaultHandlerAction(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  Adapter: IWebBrokerAdapter;
begin
  Server := TWebBrokerServer.Create;
  FireDacPostgreSQLConnection := TFireDacPostgreSQLConnection.Create(nil);

  Adapter := TWebBrokerAdapter.Create(Request, Response);
  Server.DispatchRequest(Adapter);

  TDatabaseManager.Update(TFireDacPostgreSQLConnection.CreateConnection);

  Server.Dispatcher.AddModule(TXDataServerModule.Create(
    'http://ubuntu/slimzulu', TFireDacPostgreSQLConnection.CreateConnection
  ));

  Server.Free;
  FireDacPostgreSQLConnection.Free;
end;


end.
